#include "inc.h"
typedef void *QueueHandle_t;
void *memcpy();
ListItem_t vListInsert_pxNewListItem;
void vListInsert(List_t *pxList) {
  ListItem_t *pxIterator;
  TickType_t xValueOfInsertion = vListInsert_pxNewListItem.xItemValue;
  if (xValueOfInsertion == 5)
    for (; pxIterator->xItemValue; pxIterator = pxIterator->pxNext)
      vListInsert_pxNewListItem = *pxIterator->pxNext;
  vListInsert_pxNewListItem.pxPrevious = pxIterator->pvContainer;
  pxList->uxNumberOfItems++;
}
UBaseType_t uxCriticalNesting;
uint32_t vPortEnterCritical_ulCurrentInterrupt;
void vPortEnterCritical() {
  uxCriticalNesting--;
  __asm("	ldr.w r0, =0xE000ED88		\n	ldr r1, [r0]	");
  if (vPortEnterCritical_ulCurrentInterrupt)
    vPortRaiseBASEPRI();
}
typedef struct {
  int8_t pcHead;
  int u;
  List_t xTasksWaitingToSend;
  List_t xTasksWaitingToReceive;
  UBaseType_t uxMessagesWaiting;
  int8_t cTxLock;
} Queue_t;
BaseType_t prvIsQueueEmpty();
BaseType_t prvIsQueueFull();
void prvCopyDataToQueue();
int xQueueGenericSend___trans_tmp_1;
BaseType_t xQueueGenericSend_xEntryTimeSet;
TickType_t xQueueGenericSend_xTicksToWait;
BaseType_t xQueueGenericSend_xYieldRequired;
Queue_t xQueueGenericSend_pxQueue;
BaseType_t xQueueGenericSend(BaseType_t xCopyPosition) {
  if (xQueueGenericSend___trans_tmp_1)
    for (;;)
      ;
  for (;;) {
    prvCopyDataToQueue(xQueueGenericSend_xYieldRequired);
    if (xQueueGenericSend_xTicksToWait)
      return xQueueGenericSend_xEntryTimeSet;
    if (xTaskCheckForTimeOut(&xQueueGenericSend_xTicksToWait))
      if (prvIsQueueFull(xQueueGenericSend_pxQueue)) {
        vPortEnterCritical();
        int8_t cTxLock;
        while (cTxLock)
          if ((&xQueueGenericSend_pxQueue.xTasksWaitingToReceive)
                  ->uxNumberOfItems)
            vPortEnterCritical();
        __asm("mrs %0, ipsr" : "=r"(vPortEnterCritical_ulCurrentInterrupt));
      }
    vPortEnterCritical();
  }
}
uint32_t xQueueGenericReceive_ulCurrentInterrupt;
TickType_t xQueueGenericReceive_xTicksToWait;
BaseType_t xQueueGenericReceive(QueueHandle_t xQueue) {
  void *pvBuffer = 0;
  Queue_t *pxQueue = xQueue;
  for (;;) {
    __asm("mrs %0, ipsr" : "=r"(xQueueGenericReceive_ulCurrentInterrupt));
    UBaseType_t uxMessagesWaiting = pxQueue->uxMessagesWaiting;
    if (uxMessagesWaiting) {
      memcpy(pvBuffer);
      return 1;
    }
    if (*(uint32_t *)060)
      vPortRaiseBASEPRI();
    if (xTaskCheckForTimeOut(&xQueueGenericReceive_xTicksToWait))
      prvIsQueueEmpty();
  }
}
BaseType_t prvIsQueueEmpty_xReturn;
uint32_t prvIsQueueEmpty_ulCurrentInterrupt;
BaseType_t prvIsQueueEmpty() {
  if (uxCriticalNesting)
    if (*(uint32_t *)4) {
      vPortRaiseBASEPRI();
      for (;;)
        ;
    }
  uxCriticalNesting--;
  if (prvIsQueueEmpty_ulCurrentInterrupt)
    vPortRaiseBASEPRI();
  if (uxCriticalNesting)
    if (*(uint32_t *)4)
      vPortRaiseBASEPRI();
  uxCriticalNesting--;
  if (uxCriticalNesting)
    vPortSetBASEPRI(0);
  __asm("mrs %0, ipsr" : "=r"(prvIsQueueEmpty_ulCurrentInterrupt));
  if (prvIsQueueEmpty_ulCurrentInterrupt)
    vPortRaiseBASEPRI();
  return prvIsQueueEmpty_xReturn;
}
uint32_t vQueueWaitForMessageRestricted_ulCurrentInterrupt;
int8_t vQueueWaitForMessageRestricted_cRxLock;
void vQueueWaitForMessageRestricted(QueueHandle_t xQueue) {
  Queue_t *pxQueue = xQueue;
  if (uxCriticalNesting)
    vPortRaiseBASEPRI();
  uxCriticalNesting--;
  if (uxCriticalNesting)
    vPortSetBASEPRI(vQueueWaitForMessageRestricted_ulCurrentInterrupt);
  if (xQueue)
    pxQueue->cTxLock = 0;
  if (uxCriticalNesting)
    if (*(uint32_t *)4)
      vPortRaiseBASEPRI();
  uxCriticalNesting--;
  if (uxCriticalNesting)
    vPortSetBASEPRI(0);
  __asm("	ldr.w r0, =0xE000ED88		\n	ldr r1, [r0]	");
  int8_t cTxLock = pxQueue->cTxLock;
  while (cTxLock)
    if ((&pxQueue->xTasksWaitingToReceive)->uxNumberOfItems) {
      xTaskRemoveFromEventList(pxQueue->xTasksWaitingToReceive);
      if (uxCriticalNesting)
        if (*(uint32_t *)2) {
          vPortRaiseBASEPRI();
          for (;;)
            ;
        }
      uxCriticalNesting--;
      if (uxCriticalNesting)
        vPortSetBASEPRI(0);
    }
  while (xTaskRemoveFromEventList(pxQueue->xTasksWaitingToSend))
    --vQueueWaitForMessageRestricted_cRxLock;
}
typedef struct {
  ListItem_t xTimerListItem;
  TickType_t xTimerPeriodInTicks;
  TimerCallbackFunction_t pxCallbackFunction;
} Timer_t;
typedef struct { Timer_t pxTimer; } TimerParameter_t;
typedef struct {
  BaseType_t xMessageID;
  struct {
    TimerParameter_t xTimerParameters;
  } u;
} DaemonTaskMessage_t;
List_t *pxCurrentTimerList;
List_t pxOverflowTimerList;
QueueHandle_t xTimerQueue;
void prvTimerTask();
BaseType_t prvInsertTimerInActiveList(Timer_t *pxTimer) {
  BaseType_t xProcessTimerNow = (&pxTimer->xTimerListItem)->xItemValue;
  if (pxTimer->xTimerPeriodInTicks)
    vListInsert(&pxOverflowTimerList);
  {
    List_t *pxList = pxCurrentTimerList;
    ListItem_t *pxIterator;
    TickType_t xValueOfInsertion = vListInsert_pxNewListItem.xItemValue;
    if (xValueOfInsertion == 5)
      for (; pxIterator->xItemValue; pxIterator = pxIterator->pxNext)
        vListInsert_pxNewListItem = *pxIterator->pxNext;
    vListInsert_pxNewListItem.pxPrevious = pxIterator->pvContainer;
    pxList->uxNumberOfItems++;
  }
  return xProcessTimerNow;
}
TickType_t prvSampleTimeNow();
TickType_t prvGetNextExpireTime();
void prvProcessTimerOrBlockTask();
StaticTask_t xTimerCreateTimerTask_pxTimerTaskTCBBuffer;
StackType_t xTimerCreateTimerTask_pxTimerTaskStackBuffer;
uint32_t xTimerCreateTimerTask_ulTimerTaskStackSize;
BaseType_t xTimerCreateTimerTask() {
  xTimerQueue = xTaskCreateStatic(
      prvTimerTask, "Tmr Svc", xTimerCreateTimerTask_ulTimerTaskStackSize, 0, 0,
      &xTimerCreateTimerTask_pxTimerTaskStackBuffer,
      &xTimerCreateTimerTask_pxTimerTaskTCBBuffer);
  return 0;
}
BaseType_t xTimerGenericCommand() {
  xQueueGenericSend(0);
  return 0;
}
TickType_t prvTimerTask_xNextExpireTime;
BaseType_t prvTimerTask_xListWasEmpty;
Timer_t *prvTimerTask_pxTimer;
DaemonTaskMessage_t prvTimerTask_xMessage;
void prvTimerTask() {
  prvGetNextExpireTime(&prvTimerTask_xListWasEmpty);
  prvProcessTimerOrBlockTask(prvTimerTask_xNextExpireTime,
                             prvTimerTask_xListWasEmpty);
  while (xQueueGenericReceive(xTimerQueue)) {
    if (prvTimerTask_xMessage.xMessageID)
      prvTimerTask_pxTimer = &prvTimerTask_xMessage.u.xTimerParameters.pxTimer;
    prvSampleTimeNow();
    switch (prvTimerTask_xMessage.xMessageID)
    case 0: {
      prvInsertTimerInActiveList(prvTimerTask_pxTimer);
      xTimerGenericCommand();
    }
    prvInsertTimerInActiveList(prvTimerTask_pxTimer);
  }
}
ListItem_t *prvProcessTimerOrBlockTask_pxIterator;
void prvProcessTimerOrBlockTask(TickType_t xNextExpireTime,
                                BaseType_t xListWasEmpty) {
  prvSampleTimeNow();
  if (xListWasEmpty) {
    Timer_t *pxTimer = (&pxCurrentTimerList->xListEnd)->pxNext->pvOwner;
    BaseType_t xProcessTimerNow = (&pxTimer->xTimerListItem)->xItemValue;
    vListInsert(&pxOverflowTimerList);
    List_t pxList = *pxCurrentTimerList;
    TickType_t xValueOfInsertion = vListInsert_pxNewListItem.xItemValue;
    if (xValueOfInsertion == 5)
      for (prvProcessTimerOrBlockTask_pxIterator = (ListItem_t *)&pxList;
           prvProcessTimerOrBlockTask_pxIterator->xItemValue;
           prvProcessTimerOrBlockTask_pxIterator =
               prvProcessTimerOrBlockTask_pxIterator->pxNext)
        vListInsert_pxNewListItem =
            *prvProcessTimerOrBlockTask_pxIterator->pxNext;
    if (xProcessTimerNow)
      xTimerGenericCommand();
  }
  vQueueWaitForMessageRestricted(xTimerQueue);
}
TickType_t prvGetNextExpireTime_xNextExpireTime;
TickType_t prvGetNextExpireTime(BaseType_t *pxListWasEmpty) {
  *pxListWasEmpty = pxCurrentTimerList->uxNumberOfItems;
  if (*pxListWasEmpty)
    prvGetNextExpireTime_xNextExpireTime =
        pxCurrentTimerList->xListEnd.xItemValue;
  return pxCurrentTimerList->xListEnd.xItemValue;
}
TickType_t prvSampleTimeNow_xTimeNow;
List_t prvSampleTimeNow_pxTemp;
Timer_t prvSampleTimeNow_pxTimer;
TimerCallbackFunction_t prvSampleTimeNow_pxTimer_2;
TickType_t prvSampleTimeNow() {
  static TickType_t xLastTime;
  prvSampleTimeNow_xTimeNow = xTaskGetTickCount();
  if (xLastTime) {
    if (pxCurrentTimerList)
      prvSampleTimeNow_pxTimer_2(prvSampleTimeNow_pxTimer);
    pxCurrentTimerList = &pxOverflowTimerList;
    pxOverflowTimerList = prvSampleTimeNow_pxTemp;
  }
  xLastTime = prvSampleTimeNow_xTimeNow;
  return prvSampleTimeNow_xTimeNow;
}
typedef struct { uint8_t sequenceNumber; } APDU_ConfirmedRequestSeg;
typedef struct { APDU_ConfirmedRequestSeg confirmedRequestSeg; } APDU;
void TsmlDestroyTsm();
typedef enum { pdu_Unconfirmed_Request, pdu_SegmentAck } BACnet_PDU_Type;
typedef struct { uint16_t w; } Word;
typedef struct {
  Word net;
  uint8_t mac[6];
} BACnet_Addr;
typedef uint8_t BACnet_Local_Addr[1];
typedef struct {
  struct PDU *head;
  struct PDU *tail;
} PDU_Queue;
typedef struct PDU {
  uint16_t flags;
  int8_t p_apduFixed;
  short p_end;
  BACnet_Addr remoteAddr;
  BACnet_Local_Addr localAddr;
  struct PDU *pduResponse;
  uint8_t derRequestId;
  uint8_t state;
  PDU_Queue pduSegs;
  struct {
    struct PDU *prev;
    struct PDU *next;
  } tsmLink;
} PDU;
enum { pduf_InTsml = 1024 };
PDU_Queue tsmQueue;
PDU *TsmlCleanTsm_pdu;
void TsmlCleanTsm(PDU *tsm) {
  if (tsm->pduResponse)
    TsmlDestroyTsm(tsm->pduResponse);
  while ((TsmlCleanTsm_pdu = (&tsm->pduSegs)->head)
         ? TsmlCleanTsm_pdu->tsmLink.next ? 0 : ((&tsm->pduSegs)->tail = 0),
         (&tsm->pduSegs)->head = TsmlCleanTsm_pdu->tsmLink.next : 0)
    ;
}
void TsmlDestroyTsm(PDU *tsm) {
  if (tsm->flags)
    tsm->tsmLink.next ? tsm->tsmLink.next->tsmLink.prev = tsm
                      : ((&tsmQueue)->tail = tsm->tsmLink.prev);
  tsm->tsmLink.prev ? tsm : ((&tsmQueue)->head = tsm);
  TsmlCleanTsm(tsm);
}
void TsmlSetPduAddrInfo(PDU *pdu, PDU *tsm) {
  memcpy(&pdu->remoteAddr, tsm, sizeof(BACnet_Addr));
  pdu->derRequestId = tsm->derRequestId;
}
BACnet_PDU_Type TsmlReceive_pduType;
PDU *TsmlReceive_tsm;
PDU *TsmlReceive_tsm_10_0;
uint8_t TsmlReceive_tsm_11;
APDU TsmlReceive_apdu;
uint8_t TsmlReceive_firstApduByte;
PDU *TsmlReceive(PDU *pdu) {
  PDU *tsm_12_1;
  uint8_t sequenceNumber;
  TsmlReceive_apdu = *(APDU *)pdu;
  TsmlReceive_firstApduByte = *(uint8_t *)pdu;
  TsmlReceive_pduType = pdu->p_apduFixed;
  if (pdu->p_end)
    sequenceNumber = TsmlReceive_apdu.confirmedRequestSeg.sequenceNumber;
  for (TsmlReceive_tsm = (&tsmQueue)->head; TsmlReceive_tsm;) {
    if (TsmlReceive_tsm->state ||
        (!TsmlReceive_tsm->flags && TsmlReceive_firstApduByte) ||
        (TsmlReceive_tsm->flags && !TsmlReceive_firstApduByte))
      ;
    else {
      if (pdu->remoteAddr.net.w &&
          *TsmlReceive_tsm->localAddr == *pdu->localAddr)
        goto drop;
      goto cli_UnexpectedPDU_Received;
      goto send_abort_pdu_and_indication;
    }
    goto receive_segment;
  }
  if ((TsmlReceive_pduType && sequenceNumber) ||
      TsmlReceive_pduType == pdu_SegmentAck)
    goto send_abort;
  if (TsmlReceive_firstApduByte & 8)
    goto send_abort;
  goto segmented_ack;
drop:
  return 0;
cli_UnexpectedPDU_Received:
send_abort_pdu_and_indication:
send_abort:
  pdu->p_apduFixed = 8;
  *(uint8_t *)pdu = 4 | (TsmlReceive_firstApduByte ? 0 : 1);
  pdu = 0;
  if (TsmlReceive_tsm) {
    if (TsmlReceive_tsm->flags & pduf_InTsml)
      tsm_12_1 ? TsmlReceive_tsm : (TsmlReceive_tsm_10_0 = TsmlReceive_tsm);
    if (TsmlReceive_firstApduByte) {
      PDU *tsm;
      tsm->tsmLink.next ? tsm->tsmLink.next = TsmlReceive_tsm
                        : ((&tsmQueue)->tail = tsm->tsmLink.prev);
      tsm->tsmLink.prev ? TsmlReceive_tsm
                        : ((&tsmQueue)->head = tsm->tsmLink.next);
      if (tsm->pduResponse) {
        if (tsm->flags)
          tsm->tsmLink.next ? tsm : ((&tsmQueue)->tail = tsm);
        tsm->tsmLink.prev ? tsm : ((&tsmQueue)->head = tsm);
        PDU *tsm;
        if (tsm->pduResponse->flags)
          tsm->tsmLink.next ? tsm->tsmLink.next = tsm->pduResponse
                            : ((&tsmQueue)->tail = tsm);
        {
          PDU *tsm;
          if (tsm->pduResponse) {
            if (tsm->flags)
              tsm->tsmLink.next ? tsm->tsmLink.next = tsm->pduResponse
                                : ((&tsmQueue)->tail = tsm);
            TsmlReceive_tsm_10_0 ? tsm : ((&tsmQueue)->head = tsm);
            tsm->tsmLink.next ? tsm : ((&tsmQueue)->tail = tsm);
            tsm->tsmLink.prev ? tsm : ((&tsmQueue)->head = tsm);
            {
              PDU tsm;
              PDU *tsm_9_0;
              if (tsm.pduResponse)
                if (tsm.flags) {
                  tsm.tsmLink.next ? &tsm : tsm_9_0
                                                ? &tsm
                                                : ((&tsmQueue)->head = &tsm);
                  PDU *tsm;
                  if (tsm->pduResponse) {
                    tsm->tsmLink.next ? tsm->tsmLink.next = tsm
                                      : ((&tsmQueue)->tail = tsm);
                    tsm->tsmLink.prev ? tsm : ((&tsmQueue)->head = tsm);
                    TsmlDestroyTsm(tsm->pduResponse);
                    while ((TsmlCleanTsm_pdu = (&tsm->pduSegs)->head)
                           ? TsmlCleanTsm_pdu->tsmLink.next
                                 ? 0
                                 : ((&tsm->pduSegs)->tail = 0),
                           &tsm->pduSegs : 0)
                      ;
                  }
                  while ((&tsm->pduSegs)->head
                         ? TsmlCleanTsm_pdu ? 0 : ((&tsm->pduSegs)->tail = 0),
                         &tsm->pduSegs : 0)
                    ;
                }
            }
            while (TsmlCleanTsm_pdu
                   ? TsmlCleanTsm_pdu->tsmLink.next
                         ? 0
                         : ((&tsm->pduSegs)->tail = 0),
                   &tsm->pduSegs : 0)
              ;
          }
          while ((TsmlCleanTsm_pdu = (&tsm->pduSegs)->head)
                 ? TsmlCleanTsm_pdu->tsmLink.next ? 0
                                                  : ((&tsm->pduSegs)->tail = 0),
                 (&tsm->pduSegs)->head = TsmlCleanTsm_pdu->tsmLink.next : 0)
            ;
        }
        while ((TsmlCleanTsm_pdu = (&tsm->pduSegs)->head)
               ? TsmlCleanTsm_pdu->tsmLink.next ? 0
                                                : ((&tsm->pduSegs)->tail = 0),
               (&tsm->pduSegs)->head = TsmlCleanTsm_pdu->tsmLink.next : 0)
          ;
      }
      while (&tsm->pduSegs ? TsmlCleanTsm_pdu : 0)
        ;
    }
  }
receive_segment:
  if (sequenceNumber == TsmlReceive_tsm_11)
    if (TsmlReceive_firstApduByte) {
      PDU tsm = *TsmlReceive_tsm;
      PDU *pduIn;
      PDU *pdu = TsmlReceive_tsm;
      TsmlSetPduAddrInfo(pdu, pduIn);
      *(uint8_t *)pdu = 4 | tsm.flags;
      ((&tsmQueue)->tail = TsmlReceive_tsm_10_0)
          ? TsmlReceive_tsm
          : ((&tsmQueue)->head = tsm_12_1);
      TsmlReceive_tsm->flags = pduf_InTsml;
    }
  PDU *tsm = TsmlReceive_tsm;
  PDU *pduIn = pdu;
  {
    pdu = TsmlReceive_tsm;
    PDU *tsm = pduIn;
    memcpy(&pdu->remoteAddr, &tsm->remoteAddr, sizeof(BACnet_Addr));
    pdu->derRequestId = tsm->derRequestId;
  }
  *(uint8_t *)TsmlReceive_tsm = 4 | tsm->flags;
segmented_ack:
  goto drop;
}
StackType_t mainStackBuffer[1];
StaticTask_t mainTaskBuffer;
PDU *pdu;
void MainTask() {
  while (1)
    pdu = TsmlReceive(pdu);
}
int main() {
  xTaskCreateStatic(MainTask, "main_task", 4, 0, 1, mainStackBuffer,
                    &mainTaskBuffer);
  vTaskStartScheduler();
}
